import json

import os
import threading


def logs(cnt, i):
    file = open(f".{i} JSONDecodeError.log", 'w', encoding="utf-8")
    file.write(cnt)
    file.close()


def index():
    index_file = open(f"./index/ii.json", "w", encoding="utf-8")
    invert_index = dict()
    os.chdir("./document tokens")
    for tk in os.listdir():
        print(tk)
        token_file = open(f"./{tk}", "r", encoding="utf-8")
        backup = token_file.readline()
        try:
            tkn = json.load(token_file)
        except (json.decoder.JSONDecodeError, Exception) as e:
            thread = threading.Thread(target=logs, args=(backup, tk,))
            thread.start()
        tkn = dict(tkn)
        tk = tk.replace(".json", "")
        tk = int(tk)

        for key in tkn.keys():
            if key not in invert_index.keys():
                invert_index[str(key)] = [tk]
            else:
                indexes = invert_index[key]
                indexes.append(tk)
                indexes.sort()
        token_file.close()

    # str_out = str(invert_index)
    # str_out = str_out.replace("\'", "\"")
    # str_out = dict(str_out)
    json.dump(invert_index, index_file)
    print("Invert index made!")
